import 'package:flutter/material.dart';
import 'package:fliwork_calendar/bidirectional_page_view.dart';

typedef DateTimeRangeWidgetBuilder = Widget Function(
  BuildContext context,
  DateTimeRange range,
);

class CalendarDurationView extends StatefulWidget {
  final DateTimeRangeWidgetBuilder builder;
  final Duration duration;
  final DateTime initialDate;

  CalendarDurationView({
    Key? key,
    required this.builder,
    required this.duration,
    required this.initialDate,
  }) : super(key: key);

  @override
  State<StatefulWidget> createState() => _CalendarDurationViewState();
}

class _CalendarDurationViewState extends State<CalendarDurationView> {
  @override
  Widget build(BuildContext context) {
    return BidirectionalPageView.builder(builder: (context, index) {
      final range = DateTimeRange(
        start: widget.initialDate.add(widget.duration * index),
        end: widget.initialDate.add(widget.duration * (index + 1)),
      );

      return widget.builder(
        context,
        range,
      );
    });
  }
}
